%%
%% Applet creation
%%

functor

import
   Compiler(evalExpression)
   OS(tmpnam unlink)
   Pickle(save)

   Link(makeApplet)
   
export
   makeFunctor: MakeAppletFunctor
   make:        MakeApplet

prepare

   fun {Concat Xs}
      {FoldR Xs fun {$ X Y} X#"\n"#Y end nil}
   end
   
   fun {MkFunctorText Url}
      {Concat ["functor"
               "import"
               "   Property(put)"   
               "   Main at '"#Url#"'"
               "define"
               "   {Property.put 'ozd.args' Args}"  
               "   {Wait Main}"
               "end"
              ]}
   end
   
define
  
   fun {MakeAppletFunctor Url Args}
      {Compiler.evalExpression {MkFunctorText Url} env('Args':Args) _} 
   end

   proc {MakeApplet InUrl Args OutFile}
      Tmp = {OS.tmpnam}
      {Pickle.save {MakeAppletFunctor InUrl Args} Tmp}
      Spec = spec(exec:true compress:9 args:["--include" "/"])
   in
      try
         {Link.makeApplet Tmp Spec OutFile}
      finally
         {OS.unlink Tmp}
      end
   end
   
end




